<?php
/*
 * ####################################################################
 * --------------------------------------------------------------------
 *                            XML Phorum 0.1
 *                    (Forum de discussion PHP en XML)
 *                       copyleft tobozo et leonard
 *         - tobozo@madchat.org
 *         - leonard@madchat.org
 *         - http://madchat.org/phorum/
 * --------------------------------------------------------------------
 *  Ce forum a t ralis sur la base du code
 *       de fouletexte 1.5 copyright (c) 2000 Thierry Arsicaud
 *             (http://www.echodelta.net/scriptsphp/).
 * --------------------------------------------------------------------
 * ####################################################################
 */

include("config.php");

$NombreMsgParPage=2000; // Nombre maximum de messages  afficher par page
$NombreMaxPages=1000;  // Nombre maximum de pages de messages susceptibles d'tre affiches

echo do_header();
// #############################################################################
// *****************************************************************************
// Cration du fichier "index.xml" s'il n'existe pas encore
// *****************************************************************************

if (!file_exists("index.xml")) {
   die("Error ! No index is set, please contact administrator");
   }


// **************************************************************************
// Lecture du fichier "index.dat" et stockage des donnes (identifiant,
// niveau, date, nom et sujet) dans le tableau "$index"
// **************************************************************************

$index = recuperer_index("index.xml");
$nombremsgs=count($index);

// Cas de figure o des messages ont t posts dans le forum de discussion :
// Affichage des intituls des messages dans un tableau (utilisant les
// paramtres prciss plus haut)
// **************************************************************************
// ===================================================================
// Dtermination de l'identifiant du dernier message post
// cration du tableau $tabidents, destin  reccueillir les diffrentes
// valeurs des identifiants des messages

for($compt=1;$compt<=$nombremsgs;$compt++) {
  $tabidents[$compt]=intval($index[$compt][1]);
  }

// Tri du tableau dans l'ordre inverse des valeurs
rsort($tabidents);

// Dtermination des valeurs minimum et maximum des identifiants  signaler
@ $limMaxDerMessa=$tabidents[0];

if($nombremsgs<=$nombreNouveauxMessagesSignales) {
  @ $limMinDerMessa=$tabidents[$nombremsgs-1];
  }
else {
  $limMinDerMessa=$tabidents[$nombreNouveauxMessagesSignales-1];
  }

if($nombremsgs==1) {  // Cas de figure o un seul message a t post
  $limMaxDerMessa=1;
  $limMinDerMessa=1;
  }

// suppression du tableau $tabidents
unset($tabidents);

// **************************************************************************
// Prise en compte de la valeur $p, sense indiquer le numro de la page
//  afficher - Dtermination des rangs min. et max. des messages  afficher
// dans la page
// **************************************************************************
if(@ !$p) $p=1;
$rangPMax=$nombremsgs-(($p-1)*$NombreMsgParPage);
$rangPMin=max($nombremsgs-($p*$NombreMsgParPage)+1,1);

for($rangC=$rangPMax;$rangC>=$rangPMin;$rangC--) {
  //  *** Dfinition du premier curseur ($rangC),
  // progressant par incrmentation ngative ***
  if($index[$rangC][2]==1) {  // Cas de figure o le rang du message rencontr vaut 1
         $tpl->set_var(array(
             PRE    =>"", // whitespaces($index[$rangmsgMS][2],""),
             ACTION =>"threadXML.php",
             NAME   =>$index[$rangC][1],
             ID     =>$index[$rangC][1],
             SUJET  =>stripslashes(htmlentities(strip_tags($index[$rangC][5]))),
             DATE   =>$index[$rangC][3]
             ));
         echo $tpl->parse(OUT,"threadlist");
         $rangP=$rangC+1; //  *** Dfinition du second curseur ($rangP),
                          //  progressant par incrmentation positive ***

    while(@ $index[$rangP][2]>1) {
      //  Cas de figure o le rang du message rencontr est suprieur  1
      $rangP++; // Incrmentation de $rangP
      }
    }
  }

$action= "confirmpost.php";

if ($refer) {
   $nomfichiermsg=$msg_dir."msg".$refer.".xml";
   // ======== Lecture du fichier msg__.xml et stockage des donnes ========
   // ========               dans le tableau "$message"             ========
   $tabmessage=recuperer_message($nomfichiermsg);
   $nlignes=count($tabmessage)-1;
   // Rappel : le sujet est stock dans la 4me ligne
   $sujetMsgRef=$tabmessage[4];
   // Rappel : les lignes de texte du message proprement dit sont stockes dans
   // les valeurs $tabmessage[5], $tabmessage[6]... jusqu' $tabmessage[$nlignes]
   $texteMsgRef="--- Message d'origine ---\n";

   for($compt=5;$compt<=$nlignes;$compt++) {
      $texteMsgRef=$texteMsgRef."~ ".$tabmessage[$compt];
      }

   // Note : le texte du message rfrant est stock dans la variable $texteMsgRef
   $sujet = "Re:".htmlentities(stripslashes(strip_tags($sujetMsgRef)));
   $msg = htmlentities(stripslashes(strip_tags($texteMsgRef)));
   }
else {
   $sujet = "";
   $msg = "";
   }

$tpl->set_var(array(
  TEXT     => "",
  ACTION   => $action,
  SUJET    => $sujet,
  MSG      => $msg,
  REFER    => $refer
  ));

$form = $tpl->parse(OUT,"form");

print $form;

print do_threadlist_footer();

